/* A Gui in gtk+ for MuSE - Multiple Streaming Engine
 * Copyright (C) 2002 nightolo <night@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>


#include "generic.h"
#include <profilegui.h>
#include <lamegui.h>

#include <jutils.h>
#include <jmixer.h>

#include <config.h>


GtkWidget *lame_new(GtkWidget *w)
{
	GtkWidget *verbox, *tabbola, *hbox, *giu;
	GtkWidget *tmplabel;
	GtkWidget *scaled;
	GtkWidget *ok;
	struct lamedata *l;
	GList *listola=NULL; /* recycling */

	/* FIXME: malloc but not free */
	l=(struct lamedata *) malloc(sizeof(struct lamedata));
/*	
	wind=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	l->windlame=wind;
	gtk_container_set_border_width(GTK_CONTAINER(wind), 10);
	gtk_window_set_title(GTK_WINDOW(wind), "Configure your encoder" );
	gtk_signal_connect(GTK_OBJECT(wind), "delete_event",
			(GtkSignalFunc)gtk_widget_destroy, NULL);
*/	
	verbox=gtk_vbox_new(FALSE, 10);
/*	gtk_container_add(GTK_CONTAINER(wind), verbox);*/
	
	tabbola=gtk_table_new(3, 4, FALSE);
	gtk_table_set_row_spacings(GTK_TABLE(tabbola), 10);
	gtk_table_set_col_spacings(GTK_TABLE(tabbola), 10);
	gtk_box_pack_start(GTK_BOX(verbox), tabbola, FALSE, FALSE, 0);
	
	tmplabel=gtk_label_new("bitrate");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 0, 1, 0, 1);
	l->bitrate=gtk_combo_new();
	
	listola=g_list_append(listola, (void *) "8"); 
	listola=g_list_append(listola, (void *) "16"); 
	listola=g_list_append(listola, (void *) "24"); 
	listola=g_list_append(listola, (void *) "32");
	listola=g_list_append(listola, (void *) "48");
	listola=g_list_append(listola, (void *) "56"); 
	listola=g_list_append(listola, (void *) "64"); 
	listola=g_list_append(listola, (void *) "96"); 
	listola=g_list_append(listola, (void *) "128");
	gtk_combo_set_popdown_strings(GTK_COMBO(l->bitrate), listola);
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(l->bitrate)->entry), FALSE);
	g_list_free(listola);
	listola=NULL;

	gtk_widget_set_usize(l->bitrate, 70, 22); 
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->bitrate, 1, 2, 0, 1);

	tmplabel=gtk_label_new("frequency filtering");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 2, 3, 0, 1);
	l->freqfil=gtk_combo_new();
	
	listola=g_list_append(listola, (void *) "auto");
	listola=g_list_append(listola, (void *) "none");
	listola=g_list_append(listola, (void *) "manual");
	gtk_combo_set_popdown_strings(GTK_COMBO(l->freqfil), listola);
	g_list_free(listola);
	listola=NULL;
	gtk_signal_connect(GTK_OBJECT(GTK_COMBO(l->freqfil)->entry), "changed",
			(GtkSignalFunc) gcb_set_pass, l);
	gtk_widget_set_usize(l->freqfil, 70, 22);
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(l->freqfil)->entry), FALSE);
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->freqfil, 3, 4, 0, 1);

	
	tmplabel=gtk_label_new("frequency");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 0, 1, 1, 2);
	l->freq=gtk_combo_new();
	listola=g_list_append(listola, (void *) "auto");
	listola=g_list_append(listola, (void *) "11000");
	listola=g_list_append(listola, (void *) "16000");
	listola=g_list_append(listola, (void *) "22050");
	// listola=g_list_append(listola, (void *) "32000");
	listola=g_list_append(listola, (void *) "44100");
	gtk_combo_set_popdown_strings(GTK_COMBO(l->freq), listola);
	g_list_free(listola);
	listola=NULL;
	gtk_widget_set_usize(l->freq, 70, 22);
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(l->freq)->entry), FALSE);
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->freq, 1, 2, 1, 2);

	tmplabel=gtk_label_new("lowpass Hz");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 2, 3, 1, 2);
	l->lowps=gtk_entry_new();
	gtk_entry_set_editable(GTK_ENTRY(l->lowps), FALSE);
	gtk_entry_set_text(GTK_ENTRY(l->lowps), "0");
	gtk_widget_set_usize(l->lowps, 70, 22);
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->lowps, 3, 4, 1, 2);

	tmplabel=gtk_label_new("channels");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 0, 1, 2, 3);
	l->chan=gtk_combo_new();
	listola=g_list_append(listola, (void *) "mono       3");
	listola=g_list_append(listola, (void *) "stereo     0");
	listola=g_list_append(listola, (void *) "jstereo    1");
	listola=g_list_append(listola, (void *) "dual chan  2");
	gtk_combo_set_popdown_strings(GTK_COMBO(l->chan), listola);
	gtk_combo_set_use_arrows_always(GTK_COMBO(l->chan), FALSE);
	gtk_widget_set_usize(l->chan, 80, 22);
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(l->chan)->entry), FALSE);
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->chan, 1, 2, 2, 3);
	g_list_free(listola);
	listola=NULL;
		
	tmplabel=gtk_label_new("highpass Hz");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 2, 3, 2, 3);
	l->highps=gtk_entry_new();
	gtk_entry_set_editable(GTK_ENTRY(l->highps), FALSE);
	gtk_entry_set_text(GTK_ENTRY(l->highps), "0");
	gtk_widget_set_usize(l->highps, 70, 22);
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->highps, 3, 4, 2, 3);
	
	hbox=gtk_hbox_new(FALSE, 4);
	gtk_box_pack_start(GTK_BOX(verbox), hbox, FALSE, FALSE, 0);

	tmplabel=gtk_label_new("Quality (1=best)");
	gtk_box_pack_start(GTK_BOX(hbox), tmplabel, FALSE, FALSE, 0);
	l->adj1=gtk_adjustment_new(0.0, 1.0, 9.0, 1.0, 1.0, 0.0);
	gtk_adjustment_set_value(GTK_ADJUSTMENT(l->adj1), 4.0);
	scaled=gtk_hscale_new(GTK_ADJUSTMENT(l->adj1));
	gtk_range_set_update_policy(GTK_RANGE(scaled), GTK_UPDATE_CONTINUOUS);
	gtk_scale_set_digits(GTK_SCALE(scaled), 0);
	gtk_scale_set_value_pos(GTK_SCALE(scaled), GTK_POS_LEFT);
	gtk_scale_set_draw_value(GTK_SCALE(scaled), TRUE);
	gtk_widget_set_usize(scaled, 100, 30);
	gtk_box_pack_start(GTK_BOX(hbox), scaled, FALSE, FALSE, 0);

	giu=gtk_hbox_new(TRUE, 0);
	gtk_box_pack_start(GTK_BOX(verbox), giu, FALSE, FALSE, 0);
	
	tmplabel=gtk_button_new_with_label("Browse Profile");
	gtk_object_set_data(GTK_OBJECT(tmplabel), "type", (void *)"lame");
	gtk_signal_connect(GTK_OBJECT(tmplabel), "clicked",
			(GtkSignalFunc) profile_new, l);
	gtk_box_pack_start(GTK_BOX(giu), tmplabel, TRUE, TRUE, 0);

	tmplabel=gtk_button_new_with_label("Save Profile");
	gtk_object_set_data(GTK_OBJECT(tmplabel), "type", (void *)"lame");
	gtk_signal_connect(GTK_OBJECT(tmplabel), "clicked",
			(GtkSignalFunc) profile_save, l);
	gtk_box_pack_start(GTK_BOX(giu), tmplabel, TRUE, TRUE, 0);
	
	ok=gtk_button_new_with_label("Apply");
	gtk_signal_connect(GTK_OBJECT(ok), "clicked", 
			(GtkSignalFunc)gcb_set_lame, l);
	gtk_box_pack_start(GTK_BOX(giu), ok, TRUE, TRUE, 0);
	
	/* set saved value */
	/* m'arcummanne i free su tutti gli alloc ;) */
	
	if(firstlame)
		firstlame=false;
	else
		mixer->lame.load_profile("last_active");
	lame_put(l);
	
	return verbox;
}

void lame_fill(void)
{
	/* call it after syncing lametmp with muse-core for update
	 * remaining elements */
	
	int tmp;

	tmp=lametmp.mode;
	
	switch(tmp) {
		case 0:
			strncpy(lametmp.mod, "stereo     0", sizeof(lametmp.mod));
			break;
		case 1:
			strncpy(lametmp.mod, "jstereo    1", sizeof(lametmp.mod));
			break;
		case 2:
			strncpy(lametmp.mod, "dual chan  2", sizeof(lametmp.mod));
			break;
		case 3:
			strncpy(lametmp.mod, "mono       3", sizeof(lametmp.mod));
	}
	
	switch(lametmp.lowpass) {
		case -1:
			if(lametmp.highpass==-1)
				strncpy(lametmp.freqfil, "none", sizeof(lametmp.freqfil));
			break;
		case 0:
			if(!lametmp.highpass)
				strncpy(lametmp.freqfil, "auto", sizeof(lametmp.freqfil));
			break;
		default:
			strncpy(lametmp.freqfil, "manual", sizeof(lametmp.freqfil));
	}
}

void lame_put(struct lamedata *l)
{
	/* we have got int int struct lametmp, now we need string, 
	 * sprintf will be my friend */
	
	char tmp[20];

	if(!l)
		return;

	func("lame_put(%p)", l);
	/* syncing with muse-core */

	lametmp.bps = mixer->lame.bps;
	lametmp.frequency = mixer->lame.freq;
	lametmp.mode = mixer->lame.mode;
	lametmp.highpass = mixer->lame.highpass;
	lametmp.lowpass = mixer->lame.lowpass;
	lametmp.quality = mixer->lame.quality;

	/* fill remaining parts */

	lame_fill();

	/* debug */
/*	func("GTK_GUI:: lame_put :"
		"frequency[%d] mode[%d] quality[%d] bitrate[%d] lowpass[%d], highpass[%d]",
		lametmp.frequency, lametmp.mode, lametmp.quality, lametmp.bps, 
		lametmp.lowpass, lametmp.highpass);*/
	/* fill GUI */
	
	sprintf(tmp, "%d", lametmp.bps);
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(l->bitrate)->entry), tmp);
	
	sprintf(tmp, "%d", lametmp.frequency);
	if(!(strcmp(tmp, "0")))
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(l->freq)->entry), "auto");
	else 
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(l->freq)->entry), tmp);
	
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(l->chan)->entry),
			lametmp.mod);
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(l->freqfil)->entry),
			lametmp.freqfil);

	sprintf(tmp, "%d", lametmp.lowpass);
	gtk_entry_set_text(GTK_ENTRY(l->lowps), tmp);
	sprintf(tmp, "%d", lametmp.highpass);
	gtk_entry_set_text(GTK_ENTRY(l->highps), tmp);
	gtk_adjustment_set_value(GTK_ADJUSTMENT(l->adj1), lametmp.quality);
}

void lame_get(struct lamedata *l)
{
	char *tmp;
	
	if(!l)
		return;

	func("lame_get(%p)", l);
	lametmp.bps=atoi(gtk_editable_get_chars(GTK_EDITABLE(
				GTK_COMBO(l->bitrate)->entry), 0, -1));
	
	tmp=gtk_editable_get_chars(GTK_EDITABLE(GTK_COMBO(l->freq)->entry), 0, -1);
	strncpy(lametmp.fr, tmp, sizeof(lametmp.fr));
	g_free(tmp);

	if(!(strcmp(lametmp.fr, "auto")))
		lametmp.frequency=0;
	else
		lametmp.frequency=atoi(lametmp.fr);

	tmp=gtk_editable_get_chars(GTK_EDITABLE(GTK_COMBO(l->chan)->entry), 0, -1);
	strncpy(lametmp.mod, tmp, sizeof(lametmp.mod));
	g_free(tmp);
	
	lametmp.mode=atoi(&lametmp.mod[strlen(lametmp.mod)-1]);
	lametmp.quality=(int)GTK_ADJUSTMENT(l->adj1)->value;

	lametmp.lowpass=atoi(gtk_editable_get_chars(GTK_EDITABLE(l->lowps), 0, -1));
	lametmp.highpass=atoi(gtk_editable_get_chars(GTK_EDITABLE(l->highps), 0, -1));

	tmp=gtk_editable_get_chars(GTK_EDITABLE(
				GTK_COMBO(l->freqfil)->entry), 0, -1);
	strncpy(lametmp.freqfil, tmp, sizeof(lametmp.freqfil));
	g_free(tmp);

}

void gcb_set_pass(GtkWidget *w, struct lamedata *l)
{
	char *tmp;
	
	tmp=gtk_editable_get_chars(GTK_EDITABLE(w), 0, -1);

	if(!(strcmp(tmp, "auto"))) {
		gtk_entry_set_editable(GTK_ENTRY(l->lowps), FALSE);
		gtk_entry_set_editable(GTK_ENTRY(l->highps), FALSE);
		gtk_entry_set_text(GTK_ENTRY(l->lowps), "0");
		gtk_entry_set_text(GTK_ENTRY(l->highps), "0");
		return;
	}
	if(!(strcmp(tmp, "none"))) {
		gtk_entry_set_editable(GTK_ENTRY(l->lowps), FALSE);
		gtk_entry_set_editable(GTK_ENTRY(l->highps), FALSE);
		gtk_entry_set_text(GTK_ENTRY(l->lowps), "-1");
		gtk_entry_set_text(GTK_ENTRY(l->highps), "-1");
		return;
	}	
	gtk_entry_set_editable(GTK_ENTRY(l->lowps), TRUE);
	gtk_entry_set_editable(GTK_ENTRY(l->highps), TRUE);

	g_free(tmp);
}

void gcb_set_lame(GtkWidget *w, struct lamedata *l)
{

	lame_get(l);
	
	func("GTK_GUI:: gcb_set_lame :"
		"frequency[%d] mode[%d] quality[%d] bitrate[%d] lowpass[%d], highpass[%d]",
		lametmp.frequency, lametmp.mode, lametmp.quality, lametmp.bps, 
		lametmp.lowpass, lametmp.highpass);
	if(mixer->icecastout) {
		mixer->stop_icecast();
		mixer->set_lame(lametmp.bps, lametmp.frequency, lametmp.mode,
			lametmp.quality, lametmp.highpass, lametmp.lowpass);
		mixer->set_icecast(icetmp.ip, icetmp.port, icetmp.pass, 
						icetmp.mnt, icetmp.name, icetmp.url, 
						icetmp.desc, icetmp.logtype);
	}
	else
		mixer->set_lame(lametmp.bps, lametmp.frequency, lametmp.mode,
			lametmp.quality, lametmp.highpass, lametmp.lowpass);

	gtk_notebook_set_page(GTK_NOTEBOOK(nbook), 0);
	
}

void gcb_lame_get(GtkWidget *w, gint row, gint column, GdkEventButton *s,
		struct lamedata *l)
{
	bool res=false;
	gchar *str=NULL;
	
	l->riga=row;
	
	func("gcb_lame_get(%p, %d, %d, %p)", w, row, column, s);
	gtk_clist_get_text(GTK_CLIST(w), row, column, &str);
	func("gcb_lame_get:: selected %s profile", str);
	res=mixer->lame.load_profile(str);
}

void gcb_lame_put(GtkWidget *w, struct lamedata *l)
{
	lame_put(l);
}

void gcb_lame_save(GtkWidget *w, GtkWidget *e)
{
	char *profile=NULL;

	profile=gtk_editable_get_chars(GTK_EDITABLE(GTK_COMBO(e)->entry), 0, -1);
	
	if(profile[0] == ' ') {
		warning("gcb_lame_save:: you should insert a filename");
		g_free(profile);
		return;
	}

	/* save profile and load a new one */
    mixer->lame.bps = lametmp.bps;
    mixer->lame.freq = lametmp.frequency;
    mixer->lame.mode = lametmp.mode;
    mixer->lame.highpass = lametmp.highpass;
    mixer->lame.lowpass = lametmp.lowpass;
    mixer->lame.quality = lametmp.quality;
							
	mixer->lame.write_profile(profile);
	g_free(profile);
	gtk_widget_destroy(GTK_WIDGET(gtk_object_get_data(GTK_OBJECT(w), 
					"window")));
}

void gcb_lame_rem(GtkWidget *w, struct lamedata *l)
{
/*	char profile[100];
	char profdef[100];
	char *pd;
	
	func("gcb_lame_rem(%p, %p)", w, l);
	if(!l || !lametmp->profile) {
		warning("no profile selected");
		return;
	}

	func("gcb_lame_rem:: removing profile %s", lametmp->profile);
	snprintf(profile, sizeof(profile), "[lame=%s]", lametmp->profile);
	
	profile_remove(profile);
	pd=profile_get_default("lame");
	
	if((pd) && (strstr(profile_get_default("lame"), profile))) {
		snprintf(profdef, sizeof(profdef), "lamedefault=%s", profile);
		profile_remove(profdef);
	}

	
	if(l->riga != -1) {
		gtk_clist_remove(GTK_CLIST(l->lista), l->riga);
		l->riga=-1;
	}
	else
		warning("gcb_lame_rem:: I'm sorry, you have to select a profile before");
*/	
}

void gcb_lame_default(GtkWidget *w, struct lamedata *l)
{
	char *text=NULL;

	if(l->riga==-1)
		return;

	if(GTK_TOGGLE_BUTTON(w)->active) {
		gtk_clist_get_text(GTK_CLIST(l->lista), l->riga, 0, &text);
		mixer->lame.load_profile(text);
		mixer->lame.write_profile("default");
	}

}

