/*  Linklist class
 *  used in FreeJ, MuSE and maybe others?
 *  (c) Copyright 2001 Denis Roio aka jaromil <jaromil@dyne.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 -------------------------------------------------------------------------
   linked list container class

   NOTE: add and rem don't take care of deleting pointers
   that has to be done by the process that creates them and
   knows which inheriting class they are (FreeJ: delete is done in main)
   

   $Id:
   
*/


#ifndef __linklist_h__
#define __linklist_h__

class Entry;

class Linklist {
 protected:
  Entry *first;
  Entry *last;

 public:
  Linklist();
  virtual ~Linklist();

  Entry *begin() { return(first); };
  Entry *end() { return(last); };
  int len() { return(length); };
  void add(Entry *addr);
  void add(Entry *addr, int pos);
  void rem(int pos);
  void clear();
  bool moveup(int pos);
  bool movedown(int pos);
  Entry *pick(int pos);  

  /* TODO */
  /* returns the position of the element
     as a number starting from 1
     -1 means error */
  int pos(Entry *sel);

  Entry *operator[](int pos) { return pick(pos); };

 private:
  int length;
};

class Entry {
 public:
  Entry() { };
  virtual ~Entry();
  
  Entry *next;
  Entry *prev;
};

#endif
